=== Plugins/GeodesicMeasurement/CMakeLists.txt ===
paraview_add_plugin(GeodesicMeasurement
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION "1.0"
  MODULES GeodesicMeasurement::GeodesicMeasurementFilters
  MODULE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/Filters/vtk.module")
